package com.ruoyi.approvalFlow.mapper;

import com.ruoyi.approvalFlow.domain.AuditItems;
import com.ruoyi.approvalFlow.domain.AuditPaths;
import com.ruoyi.approvalFlow.domain.AuditPathsLevels;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;
import java.util.Objects;


/**
 * 审批流任务明细Mapper接口
 *
 * @author ruoyi
 * @date 2021-01-21
 */
public interface AuditItemsMapper {
    /**
     * 查询审批流任务明细
     *
     * @param id 审批流任务明细ID
     * @return 审批流任务明细
     */
    public AuditItems selectAuditItemsById(Long id);

    /**
     * 查询审批流任务明细列表
     *
     * @param auditItems 审批流任务明细
     * @return 审批流任务明细集合
     */
    public List<AuditItems> selectAuditItemsList(AuditItems auditItems);

    /**
     * 新增审批流任务明细
     *
     * @param auditItems 审批流任务明细
     * @return 结果
     */
    public int insertAuditItems(AuditItems auditItems);

    /**
     * 修改审批流任务明细
     *
     * @param auditItems 审批流任务明细
     * @return 结果
     */
    public int updateAuditItems(AuditItems auditItems);

    /**
     * 删除审批流任务明细
     *
     * @param id 审批流任务明细ID
     * @return 结果
     */
    public int deleteAuditItemsById(Long id);

    /**
     * 凯和若依端删除订单并把审批流删除
     * @param id
     * @return
     */
    public int deleteAuditItemsByBillId(@Param("id") Long id);

    /**
     * 批量删除审批流任务明细
     *
     * @param ids 需要删除的数据ID
     * @return 结果
     */
    public int deleteAuditItemsByIds(Long[] ids);

    /**
     *  查看审批流
     * @param auditItems 条件
     * @return 结果
     */
    List<Map<String, Object>> selectAuditItems(AuditItems auditItems);

    /**
     * 删除后续审批
     * @param auditItems 条件
     * @return
     */
    int deleteUpLevelId(AuditItems auditItems);

    /**
     *  弹窗页查询审批流
     * @param auditItems 条件
     * @return
     */
    List<Map<String, Object>> selectWarehouseApprover(AuditItems auditItems);

    /**
     *  撤回审批
     * @param auditItems
     * @return
     */
    public int deletePurchaseApproval(AuditItems auditItems);

    /**
     *  更新下一级审批状态
     * @param auditItems
     * @return
     */
    public int updateAuditStatus(AuditItems auditItems);

    /**
     * 查询审批流配置主
     * @return 结果
     */
    public int selectCountAuditItems();
}
